# -*- coding: utf-8 -*-
"""
Created on Sun Nov 29 11:01:42 2020

@author: Lucia
"""


# =============================================================================
# Nosological models DISNET analysis MAIN SCRIPT
# =============================================================================


#-------------------------------
# IMPORTING THE NEEDED LIBRARIES
#-------------------------------


# import mysql.connector
# import json

import pandas as pd
#import numpy as np

# from datasets_preparation.associations import disease_gene
# from datasets_preparation.associations import disease_protein
# from datasets_preparation.associations import disease_pathway
# from datasets_preparation.associations import disease_variant

# from datasets_preparation.distances import compute
# from datasets_preparation.distances import visualize_one_plot
# from datasets_preparation.distances import visualize_subplots

# from datasets_preparation.feature_matrices import generate

# from preprocessing import dimensionality_reduction

# from clustering import dbscan
# from clustering import hdbscan as HD
# from clustering import kmeans
# from clustering import hierarchic
# from clustering import optics

# from clustering.hierarchic import get_linkage, plt_sub_dendrogram




#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#------------------------------
# PREPARING DATABASE CONNECTION
#------------------------------


# conn_param_file = 'disnet_conn_config.json'
# # Setting the connection to the database

# # The connection configuration is stored in a JSON file
# with open(conn_param_file, 'r') as f:
#     configdb = json.load(f) # The JSON file is translated to a pyhton dictionary

# # Stablishing the connection with the parameters in the dictionary
# cnx = mysql.connector.connect(**configdb)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#------------------------------
# VARIABLES DECLARATION
#------------------------------


vectors = ('bool', 
           'real',
           )
datasets = ('complete', 
            'inner',
            )

features = {'bool': ('gene',
                     'protein',
                     'pathway',
                     'variant'), 
            'real': ('gene',
                     'variant'
                     )}

distance_metrics = {'bool': ('jaccard',
                             'dice',
                             'hamming',
                             'sokalsneath'
                             ), 
                    'real': ('cosine',
                             'euclidean',
                             'minkowski',
                             'correlation'
                             )}

# KMeans numbers of clusters
# ranges = {'gene': range(200,1000,200),
#           'protein': range(200,1000,200),
#           'pathway' :range(20,300,20),
#           'variant': range(200,1000,200)}

# Optimization parameters
# epsilons_opt = (0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9)
# ms_opt = (2, 3, 5, 10, 30)
# n_clusters_opt = (5, 6, 7, 8, 9, 10) # Number of cluster in hierarchic





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#-------------------------------------------
# Generate DISEASE_FEATURE association lists
#-------------------------------------------


# for vector in vectors:
    
#     for dataset in datasets:
        
#         if vector == 'bool':        
#             disease_gene(vector, dataset, cnx)
#             disease_protein(dataset, cnx)
#             disease_pathway(dataset, cnx)
#             disease_variant(vector, dataset, cnx)
        
#         else:
#             disease_gene(vector, dataset, cnx)
#             disease_variant(vector, dataset, cnx)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#--------------------------
# Generate FEATURE MATRICES
#--------------------------


# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:
            
#             # Importing csvs with disease-feature relationships to pandas dataframes
#             disease_feature = pd.read_csv('data/disease_feature/' + dataset + '/' + vector + '/disease_' + feature + '.csv')
            
#             # Obtaining list of diseases without duplicates
#             disease_feature_set = disease_feature['disease_id'].sort_values(ascending = True).drop_duplicates().to_list()
        
        
        
#             print('Obtaining ' + feature + 's matrix')
#             feature_matrix = generate(disease_feature, 
#                                       list(set(disease_feature_set)),
#                                       disease_feature['feature_id'].sort_values(ascending = True).drop_duplicates().to_list())
#             feature_matrix.to_csv('data/feature_matrices/' + dataset + '/' + vector + '/' + feature + 's_feature_matrix.csv', index=False)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#---------------------------
# Compute DISTANCE MATRICES
#---------------------------


# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:
            
#             feature_matrix = pd.read_csv('data/feature_matrices/' + dataset + '/' + vector + '/' + feature + 's_feature_matrix.csv')
    
#             for ind in distance_metrics[vector]:
                
#                 print('\t- Obtaining ' + ind + ' distance')
#                 distance_matrix = compute(feature_matrix, ind)
#                 np.save('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy', distance_matrix)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#-----------------------
# Plot DISTANCE MATRICES
#-----------------------

# for vector in vectors:
    
#     for dataset in datasets:
        
#         feat_d_list = list()
#         for feature in features[vector]:        
            
#             ind_d_list = list()
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 # visualize_one_plot(dist_matrix, ind, feature, dataset)        
#                 ind_d_list.append(dist_matrix)    
#             feat_d_list.append(ind_d_list)
            
#         visualize_subplots(feat_d_list, features[vector], distance_metrics[vector], dataset, vector)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#------------------------
# Parameters OPTIMIZATION
#------------------------


# DBSCAN
# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:        
            
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 optimiz = dbscan.do_optimization(dist_matrix, ind, ms_opt, epsilons_opt)
                
#                 optimiz.to_csv('results/optimizations/dbscan/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv', index = False)



# HDBSCAN
# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:        
            
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 optimiz = HD.do_optimization(dist_matrix, ind)
                
#                 optimiz.to_csv('results/optimizations/hdbscan/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv', index = False)




# KMeans
# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:        
            
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 optimiz = kmeans.do_optimization(dist_matrix, ind, ranges[feature])
                
#                 optimiz.to_csv('results/optimizations/kmeans/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv', index = False)




# Hierarchic
# for vector in vectors:
    
#     for dataset in datasets:
        
#         # link_matrix_list = list()
#         for feature in features[vector]:        
            
#             # ind_d_list = list()
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 optimiz = hierarchic.do_optimization(dist_matrix, ind, n_clusters_opt)
                
#                 optimiz.to_csv('results/optimizations/hierarchic/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv', index = False)
                
#                 # hierarchic.plt_dendrogram(dist_matrix, "complete")
#                 # link_matrix = get_linkage(dist_matrix, "single", ind)
                
#                 # ind_d_list.append(link_matrix)    
                
#             # link_matrix_list.append(ind_d_list)
#         # plt_sub_dendrogram(link_matrix_list, vector, features[vector], distance_metrics[vector], dataset)



# OPTICS
# for vector in vectors:
    
#     for dataset in datasets:
        
#         for feature in features[vector]:        
            
#             for ind in distance_metrics[vector]:
                
#                 dist_matrix = np.load('data/distances/' + dataset + '/' + vector + '/' + ind + '_' + feature + '.npy')
                
#                 optimiz = optics.do_optimization(dist_matrix, ind, ms_opt)
                
#                 optimiz.to_csv('results/optimizations/optics/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv', index = False)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------




#----------------
# Joining results
#----------------

all_results = pd.DataFrame(columns = ['Dataset',
                                      'Vector',
                                      'Algorithm',
                                      'Feature',
                                      'Distance',
                                      'MinPts',
                                      'Epsilon',
                                      'Clusters',
                                      'Noise',
                                      'Silhouette',
                                      'SSE',
                                      'Calinski-Harabasz',
                                      'Davies-Bouldin'])

all_optim_dfs = list() # List will the dataframes with all optimizations


# DBSCAN
for dataset in datasets:
    for vector in vectors:
        
        for feature in features[vector]:        
            
            for ind in distance_metrics[vector]:
                
                opt_dbscan_results = pd.read_csv('results/optimizations/dbscan/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv')
                opt_dbscan_results['Dataset'] = dataset
                opt_dbscan_results['Vector'] = vector
                opt_dbscan_results['Algorithm'] = 'DBSCAN'
                opt_dbscan_results['Feature'] = feature
                opt_dbscan_results['SSE'] = ''
                opt_dbscan_results.rename(columns = {'Similarity':'Distance',
                                                      'Cluster':'Clusters'}, inplace=True)
                opt_dbscan_results = opt_dbscan_results[['Dataset',
                                                          'Vector',
                                                          'Algorithm',
                                                          'Feature',
                                                          'Distance',
                                                          'MinPts',
                                                          'Epsilon',
                                                          'Clusters',
                                                          'Noise',
                                                          'Silhouette',
                                                          'SSE',
                                                          'Calinski-Harabasz',
                                                          'Davies-Bouldin']]
                all_optim_dfs.append(opt_dbscan_results)


# HDBSCAN
for dataset in datasets:
    for vector in vectors:
        
        for feature in features[vector]:        
            
            for ind in distance_metrics[vector]:
                
                opt_hdbscan_results = pd.read_csv('results/optimizations/hdbscan/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv')
                opt_hdbscan_results['Dataset'] = dataset
                opt_hdbscan_results['Vector'] = vector
                opt_hdbscan_results['Algorithm'] = 'HDBSCAN'
                opt_hdbscan_results['Feature'] = feature
                opt_hdbscan_results['MinPts'] = ''
                opt_hdbscan_results['Epsilon'] = ''
                opt_hdbscan_results['SSE'] = ''
                opt_hdbscan_results.rename(columns = {'Similarity':'Distance',
                                                      'Cluster':'Clusters'}, inplace=True)
                opt_hdbscan_results = opt_hdbscan_results[['Dataset',
                                                          'Vector',
                                                          'Algorithm',
                                                          'Feature',
                                                          'Distance',
                                                          'MinPts',
                                                          'Epsilon',
                                                          'Clusters',
                                                          'Noise',
                                                          'Silhouette',
                                                          'SSE',
                                                          'Calinski-Harabasz',
                                                          'Davies-Bouldin']]
                all_optim_dfs.append(opt_hdbscan_results)
                
# KMeans
for dataset in datasets:
    for vector in vectors:
        
        for feature in features[vector]:        
            
            for ind in distance_metrics[vector]:
                
                opt_kmeans_results = pd.read_csv('results/optimizations/kmeans/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv')
                opt_kmeans_results['Dataset'] = dataset
                opt_kmeans_results['Vector'] = vector
                opt_kmeans_results['Algorithm'] = 'KMeans'
                opt_kmeans_results['Feature'] = feature
                opt_kmeans_results['MinPts'] = ''
                opt_kmeans_results['Noise'] = ''
                opt_kmeans_results['Epsilon'] = ''
                opt_kmeans_results.rename(columns = {'Similarity':'Distance',
                                                      'Cluster':'Clusters'}, inplace=True)
                opt_kmeans_results = opt_kmeans_results[['Dataset',
                                                          'Vector',
                                                          'Algorithm',
                                                          'Feature',
                                                          'Distance',
                                                          'MinPts',
                                                          'Epsilon',
                                                          'Clusters',
                                                          'Noise',
                                                          'Silhouette',
                                                          'SSE',
                                                          'Calinski-Harabasz',
                                                          'Davies-Bouldin']]
                all_optim_dfs.append(opt_kmeans_results)

# OPTICS
for dataset in datasets:
    for vector in vectors:
        
        for feature in features[vector]:        
            
            for ind in distance_metrics[vector]:
                
                opt_optics_results = pd.read_csv('results/optimizations/optics/' + dataset + '/' + vector + '/' + feature + 's_' + ind + '.csv')
                opt_optics_results['Dataset'] = dataset
                opt_optics_results['Vector'] = vector
                opt_optics_results['Algorithm'] = 'OPTICS'
                opt_optics_results['Feature'] = feature
                opt_optics_results['MinPts'] = ''
                opt_optics_results['Epsilon'] = ''
                opt_optics_results['SSE'] = ''
                opt_optics_results.rename(columns = {'Similarity':'Distance',
                                                      'Cluster':'Clusters'}, inplace=True)
                opt_optics_results = opt_optics_results[['Dataset',
                                                          'Vector',
                                                          'Algorithm',
                                                          'Feature',
                                                          'Distance',
                                                          'MinPts',
                                                          'Epsilon',
                                                          'Clusters',
                                                          'Noise',
                                                          'Silhouette',
                                                          'SSE',
                                                          'Calinski-Harabasz',
                                                          'Davies-Bouldin']]
                all_optim_dfs.append(opt_optics_results)
                

all_results = pd.concat(all_optim_dfs, sort = False)
all_results.to_csv('results/optimizations/all_results.csv', index = False)





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------



#---------------------
# BEST OBTAINED MODELS
#---------------------

# dataset = 'complete'
# vector = 'real'
# ind = 'cosine'
# feature = 'gene'

# diseases_optics, clusters_optics = optics.do_clustering_best_model(dataset, vector, ind, feature)
# diseases_optics.to_csv('results/clusters/optics_' + dataset + '_' + vector + '_' + ind + '_' + feature + 's.csv')

# feat_dis = pd.read_csv('D:/Users/Lucia/Documents/coding-disnet/nosological_models/nosological_models_analysis/data/feature_matrices/' + dataset + '/' + vector + '/' + feature + 's_feature_matrix.csv')
# optics.simluations(50, feat_dis, ind, 2, feature, vector, dataset)

# dataset = 'complete'
# vector = 'real'
# ind = 'minkowski'
# feature = 'gene'

# diseases_dbscan, clusters_dbscan = dbscan.do_clustering_best_model(dataset, vector, ind, feature, 2, 0.9)
# diseases_dbscan.to_csv('results/clusters/dbscan_' + dataset + '_' + vector + '_' + ind + '_' + feature + 's.csv')





#------------------------------------------------------------------------------
#------------------------------------------------------------------------------

#----------------------
# CLOSING DB CONNECTION
#----------------------


# cnx.close()