# -*- coding: utf-8 -*-
"""
Created on Sun Nov 29 10:53:44 2020

@author: Lucia
"""

# Importing the needed libraries

import pandas as pd




def disease_gene(vector, dataset, cnx):
    
    if vector == 'bool' and dataset == 'complete':
        query_disease_gene = """
                    SELECT DISTINCT
                        d.disease_id, dg.gene_id AS feature_id
                    FROM
                        disnet_biolayer.disease d
                            INNER JOIN
                        disnet_biolayer.disease_gene dg ON d.disease_id = dg.disease_id
                            INNER JOIN
                        disnet_biolayer.has_semantictype hst ON d.disease_id = hst.disease_id
                            INNER JOIN
                        disnet_biolayer.semantictype st ON hst.tui = st.tui
                    WHERE
                        hst.tui = 'T047'
                    ;
                    """
        
   
    elif vector == 'real' and dataset == 'complete':
        query_disease_gene = """
                    SELECT DISTINCT
                        d.disease_id, dg.gene_id AS feature_id, dg.score
                    FROM
                        disnet_biolayer.disease d
                            INNER JOIN
                        disnet_biolayer.disease_gene dg ON d.disease_id = dg.disease_id
                            INNER JOIN
                        disnet_biolayer.has_semantictype hst ON d.disease_id = hst.disease_id
                            INNER JOIN
                        disnet_biolayer.semantictype st ON hst.tui = st.tui
                    WHERE
                        hst.tui = 'T047'
                    ;
                    """
    
   
    elif vector == 'bool' and dataset == 'inner':
        query_disease_gene = """
                    SELECT DISTINCT 
                        d.disease_id, dg.gene_id AS feature_id
                    FROM
                        disnet_biolayer.disease d
                            INNER JOIN
                        disnet_biolayer.disease_gene dg ON d.disease_id = dg.disease_id
                            INNER JOIN
                        disnet_biolayer.disease_variant dv ON d.disease_id = dv.disease_id
                            INNER JOIN
                        disnet_biolayer.encodes e ON dg.gene_id = e.gene_id
                            INNER JOIN
                        disnet_biolayer.gene_pathway gp ON dg.gene_id = gp.gene_id
                            INNER JOIN
                        disnet_biolayer.has_semantictype hst ON d.disease_id = hst.disease_id
                            INNER JOIN
                        disnet_biolayer.semantictype st ON hst.tui = st.tui
                    WHERE
                        hst.tui = 'T047'
                    ;
                    """
    
    else: # Vector == 'real' and dataset == 'inner'
        query_disease_gene = """
                    SELECT DISTINCT
                        d.disease_id, dg.gene_id AS feature_id, dg.score
                    FROM
                        disnet_biolayer.disease d
                            INNER JOIN
                        disnet_biolayer.disease_gene dg ON d.disease_id = dg.disease_id
                            INNER JOIN
                        disnet_biolayer.disease_variant dv ON d.disease_id = dv.disease_id
                            INNER JOIN
                        disnet_biolayer.encodes e ON dg.gene_id = e.gene_id
                            INNER JOIN
                        disnet_biolayer.gene_pathway gp ON dg.gene_id = gp.gene_id
                            INNER JOIN
                        disnet_biolayer.has_semantictype hst ON d.disease_id = hst.disease_id
                            INNER JOIN
                        disnet_biolayer.semantictype st ON hst.tui = st.tui
                    WHERE
                        hst.tui = 'T047'
                    ;
                    """
    disease_gene = pd.read_sql_query(query_disease_gene, con = cnx)
    disease_gene.to_csv('data/disease_feature/' + dataset + '/' + vector +'/disease_gene.csv', index=False)


def disease_protein(dataset, cnx):
    return


def disease_pathway(dataset, cnx):
    return

def disease_variant(vector, dataset, cnx):
    return